import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;

public class playGameLogic {
    static Logger logger = LogManager.getLogger(playGameLogic.class);

    static String playGame(int gameNumber, String firstPlayer, WebDriverWait wait, WebDriver driver) throws InterruptedException {
        List<int[]> cells = new ArrayList<>(Arrays.asList(
                new int[]{0, 0}, new int[]{0, 1}, new int[]{0, 2},
                new int[]{1, 0}, new int[]{1, 1}, new int[]{1, 2},
                new int[]{2, 0}, new int[]{2, 1}, new int[]{2, 2}
        ));
        logger.debug("Текущий список доступных ячеек: " + cells);
        String currentPlayer = firstPlayer;
        String[][] board = new String[3][3];

        simulatePauseLogic.simulatePause(409,410);

        for (int i = 0; i < 9; i++) {
            if (cells.isEmpty()) {
                logger.info("Draw.");
                return "D";
            }

            logger.debug("Текущий список доступных ячеек: " + cells);
            int randomIndex = new Random().nextInt(cells.size());
            int[] cell = cells.remove(randomIndex);

            if (!playMoveLogic.playMove(cell[0], cell[1], currentPlayer, wait, driver)) {
                i--;
                continue;
            }

            board[cell[0]][cell[1]] = currentPlayer;


            printBoardLogic.printBoardState(wait, driver);


            if (checkWinConditionLogic.checkWinCondition(board, currentPlayer)) {
                logger.info(String.format("Player %s win -  № %d!%n", currentPlayer, gameNumber));
                return currentPlayer;
            }


            currentPlayer = currentPlayer.equals("X") ? "O" : "X";
        }


        logger.info("Game № " + gameNumber + " it's over draw.");
        return "D";
    }
}
