import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;

import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

public class screenshotLogic {

    static Logger logger = LogManager.getLogger(screenshotLogic.class);

    public static void takeScreenshot(String testName, String fileName) {
        try {

            File screenshotDir = new File("screenshots/" + testName);
            if (!screenshotDir.exists()) {
                if (screenshotDir.mkdirs()) {
                    logger.info("Создана директория для скриншотов: " + screenshotDir.getAbsolutePath());
                } else {
                    logger.error("Не удалось создать директорию для скриншотов");
                }
            }


            Robot robot = new Robot();
            java.awt.Rectangle screenRect = new java.awt.Rectangle(Toolkit.getDefaultToolkit().getScreenSize());
            BufferedImage screenImage = robot.createScreenCapture(screenRect);


            File screenshotFile = new File(screenshotDir, fileName);
            ImageIO.write(screenImage, "png", screenshotFile);
            logger.info("Скриншот сохранен: " + screenshotFile.getAbsolutePath());

        } catch (AWTException e) {
            logger.error("Ошибка при создании скриншота: " + e.getMessage());
        } catch (IOException e) {
            logger.error("Ошибка при сохранении скриншота: " + e.getMessage());
        }
    }
}
