import io.qameta.allure.AllureId;
import io.qameta.allure.Description;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.ThreadContext;
import org.junit.jupiter.api.*;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebDriverException;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.support.ui.WebDriverWait;

import java.time.Duration;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

public class testWinO {
    static Logger logger = LogManager.getLogger(testWinO.class);
    static WebDriverWait wait;
    static WebDriver driver;
    public static boolean testFailed;
    private static String testName = null;

    @BeforeEach
    public void setUp(TestInfo testInfo) {
        driver = new ChromeDriver();

        wait = new WebDriverWait(driver, Duration.ofSeconds(10));


        testName = testInfo.getDisplayName().replaceAll("[^a-zA-Z0-9_\\-]", "_");
        ThreadContext.put("testName", "TestNameValue");
        ThreadContext.put("testName", testName);
        logger.info("Запуск теста: " + testName);


        driver.get("https://g.co/kgs/NKFefHW");
        logger.info("Перешли на страницу игры \"Крестики-нолики\".");
    }

    @AfterEach
    public void tearDown(TestInfo testInfo) {

        String testName = testInfo.getDisplayName().replaceAll(" ", "_");
        ThreadContext.put("testName", testName);
        logger.info("Завершение теста: " + testName);

        if (driver != null) {

            try {
                if (testFailed) {
                    String screenshotFileName = String.format("screenshot_%s_%s.png",
                            testName,
                            LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd_HH-mm-ss")));
                    screenshotLogic.takeScreenshot(testName, screenshotFileName);
                    logger.info("Скриншот сохранен: " + screenshotFileName);
                }

            } catch (WebDriverException e) {
                logger.error("Ошибка при захвате скриншота: " + e.getMessage());
            } finally {
                driver.quit();
                logger.info("Закрыли браузер.");
            }
        }

        ThreadContext.clearAll();
    }


    @DisplayName("testWin0")
    @Description("Сценарий победы 0")
    @AllureId("004")
    @Test
    public void testWin0func() throws InterruptedException {
        simulatePauseLogic.simulatePause(899,910);
        selectGameModeLogic.selectGameMode(wait, driver);
        simulatePauseLogic.simulatePause(409,410);


        playMoveLogic.playMove(0, 2, "X", wait, driver);
        simulatePauseLogic.simulatePause(409,410);


        playMoveLogic.playMove(0, 1, "0", wait, driver);
        simulatePauseLogic.simulatePause(409,410);


        playMoveLogic.playMove(1, 2, "X", wait, driver);
        simulatePauseLogic.simulatePause(409,410);


        playMoveLogic.playMove(1, 1, "0", wait, driver);
        simulatePauseLogic.simulatePause(409,410);


        playMoveLogic.playMove(2, 0, "X", wait, driver);

        simulatePauseLogic.simulatePause(409,410);
        playMoveLogic.playMove(2, 1, "0", wait, driver);


        String[][] board = new String[3][3];
        board[0][2] = "X";
        board[0][1] = "0";
        board[1][2] = "X";
        board[1][1] = "0";
        board[2][0] = "X";
        board[2][1] = "0";


        boolean is0Winner = checkWinConditionLogic.checkWinCondition(board, "0");
        Assertions.assertTrue(is0Winner, "Нолик не выиграл, хотя должен был!");


       logger.info("Нолик победил");
    }

}
